#include <windows.h>
#include <dos.h>
#include <direct.h>
#include <wfext.h>

/*-------------------------------------------------------------------*/
/* DRTRASH                                                           */
/*                                                                   */
/* This program is intended for use with Dropper, a desktop manager. */
/* You can leave it on the desktop, ready for activation.  It allows */
/* you to delete files by dragging them onto this icon instead of    */
/* having to have a program running.                                 */
/*                                                                   */
/* This program is Copyright 1993 by David C. Elliott.   It's        */
/* freeware, not shareware, and anyone can use or distribute it as   */
/* long as they don't sell it.                                       */
/*                                                                   */
/* Version 2.0 by Niccolo Rigacci - 9 Nov 1995                       */
/* Using DropTrash with DeZkTop 1.8 (a Program Manager sobstitute)   */
/* I found a bug that now is fixed. See DRTRASH.TXT for more info.   */
/*-------------------------------------------------------------------*/


/*-------------------------------------------------------------------*/
/* about                                                             */
/*-------------------------------------------------------------------*/
static void about()
   {
   MessageBox((HWND)NULL, "DropTrash 2.0\nCopyright 1993 David C. Elliott\nVersion 2.0 by Niccol Rigacci - 1995", "About DropTrash", MB_OK);
   }


/*-------------------------------------------------------------------*/
/* removeFile                                                        */
/*-------------------------------------------------------------------*/
static void removeFile(LPSTR name)
   {
   OFSTRUCT ofs;

   _dos_setfileattr(name, _A_NORMAL);
   OpenFile(name, &ofs, OF_DELETE);
   }


/*-------------------------------------------------------------------*/
/* removeDir                                                         */
/*-------------------------------------------------------------------*/
static void removeDir(LPSTR name)
   {
   struct _find_t info;
   unsigned nomore;
	
   /* Change Current Working Directory. Return if error.*/
   if (_chdir(name)) return;
   
   /* Delete all files. */
   nomore = _dos_findfirst("*.*", _A_RDONLY | _A_HIDDEN | _A_SYSTEM, &info);
   while (!nomore)
      {
      removeFile(info.name);
      nomore = _dos_findnext(&info);
      }

   /* Delete all nested subdirectories. */
   nomore = _dos_findfirst("*.*", _A_SUBDIR, &info);
   while (!nomore)
      {
      if (info.attrib & _A_SUBDIR && lstrcmp(info.name, ".") && lstrcmp(info.name, "..")) removeDir(info.name);
      nomore = _dos_findnext(&info);
      }

   /* Get rid of the directory. */
   _chdir("..");
   _rmdir(name);
   }


/*-------------------------------------------------------------------*/
/* WinMain                                                           */
/*-------------------------------------------------------------------*/
int PASCAL WinMain(HANDLE hInstance,
                   HANDLE hPrevInstance,
                   LPSTR  lpszCmdLine,
                   int    nCmdShow)
   {
   LPSTR cp, lcp;
   char chr;
   BOOL del = TRUE;
   BOOL Interactive = FALSE;
   unsigned attrib;
	
   /* If no arguments given, display About box. */
   if (lpszCmdLine == NULL || *lpszCmdLine == '\0')
      {
      about();
      return 0;
      }
	
   /* If Ctrl key is pressed turns on Interactive mode. */
   if (GetKeyState(VK_CONTROL) & 0x8000) Interactive = TRUE;

   /* If first argument is /i, /I, -i or -I turns on Interactive mode. */
   cp = lpszCmdLine;     
   if ((*cp == '-' || *cp == '/') && (cp[1] == 'i' || cp[1] == 'I'))
      {
      cp += 2;
      Interactive = TRUE;
      }
   while (*cp == ' ') cp++;

   /* Delete cycle, multiple arguments accepted. */
   for ( ; ; )
      {
      lcp = cp;
      while (*cp && *cp != ' ') cp++;
      chr = *cp;
      *cp = '\0';
      /* Now lcp points to the begin of the name, cp to the zero-terminating char. */
      if (Interactive)
         {
         switch (MessageBox((HWND)NULL, lcp, "Delete file", MB_YESNOCANCEL | MB_ICONQUESTION))
            {
            case IDYES:
               del = TRUE;
               break;
            case IDNO:
               del = FALSE;
               break;
            case IDCANCEL:
               return 0;
            }
         }
      if (del)
         {
         if (_dos_getfileattr(lcp, &attrib) == 0)
            {
            if (attrib & _A_SUBDIR)
               {
               if (_chdrive(lcp[0] - '@') == 0) removeDir(lcp);
               }
            else
               {
               removeFile(lcp);
               }
            }
         }
      if (chr == '\0') break;
      cp++;
      while (*cp == ' ') cp++;
      if (*cp == '\0') break;
      }
   /* Refresh all File Manager windows. */
   SendMessage(HWND_BROADCAST, FM_REFRESH_WINDOWS, 1, 0);
   return 0;
   }

